<? 
    function ip2hex( $ip ) 
    { 
        //------------ IPAddress 2 Hex. 
        $tmp = explode( ".", $ip ) ; 

        $hex = sprintf( "%02X%02X%02X%02X", $tmp[0], $tmp[1], $tmp[2], $tmp[3] ) ; 

        return ( $hex ) ; 
    } 

    function hex2ip( $hex ) 
    { 
        //---------- Hex 2 IPAddress. 
        // $ip = sprintf( "%3d.%3d.%3d.%3d", hexdec( substr($hex,0,2) ), hexdec( substr($hex,2,2) ), hexdec( substr($hex,4,2) ), hexdec( substr($hex,6,2) ) ) ; 
        $ip = hexdec( substr($hex,0,2) ).".".hexdec( substr($hex,2,2) ).".".hexdec( substr($hex,4,2) ).".".hexdec( substr($hex,6,2) ) ; 
        return ( $ip ) ; 
    } 



    function ip2bin( $ip ) 
    { 
        //----------- IPAddress 2 Bin. 
        $tmp = explode( ".", $ip ) ; 

        $bin = sprintf( "%08d%08d%08d%08d", decbin($tmp[0]), decbin($tmp[1]), decbin($tmp[2]), decbin($tmp[3]) ) ; 

        return( $bin ) ; 
    } 

    function bin2ip( $bin ) 
    { 
        //------------ Bin 2 IPAddress. 
        $ip = bindec(substr($bin,0,8)).".".bindec(substr($bin,8,8)).".".bindec(substr($bin,16,8)).".".bindec(substr($bin,24,8)) ; 

        return( $ip ) ; 
    } 


    function ip2dec( $ip ) 
    { 
        //---------- IPAddress 2 Dec. 
        $tmp = explode( '.', $ip ) ; 

        $dec = ( ($tmp[0]*pow(2,24)) + ($tmp[1]*pow(2,16)) + ($tmp[2]*pow(2,8)) + ($tmp[3]*pow(2,0)) ) ; 


        return( $dec ) ; 
    } 

    function dec2ip( $dec ) 
    { 
        //----------- Dec 2 IPAddress. 
        $tmp[0] = floor( (double)($dec/pow(2,24)) ) ; $dec -= $tmp[0]*pow(2,24) ; 
        $tmp[1] = floor( (double)($dec/pow(2,16)) ) ; $dec -= $tmp[1]*pow(2,16) ; 
        $tmp[2] = floor( (double)($dec/pow(2,8)) ) ; $dec -= $tmp[2]*pow(2,8) ; 
        $tmp[3] = floor( (double)($dec/pow(2,0)) ) ; $dec -= $tmp[3]*pow(2,0) ; 

        $ip = $tmp[0].".".$tmp[1].".".$tmp[2].".".$tmp[3] ; 

        return( $ip ) ; 
    } 
?>